<template>
  <div>
    <div class="fullHistory_body commissions_fullhistory">
      <div class="table_head">
        <div class="table-tr flex flex-middle">
          <div class="table-th">{{$t('common.time')}}</div>
          <div class="table-th">{{$t('common.wallet')}}</div>
          <div class="table-th">{{$t('common.bets')}}</div>
          <div class="table-th">{{$t('common.commissions')}}</div>
          <div class="table-th"></div>
        </div>
      </div>
      <div class="table">
        <div class="table_date-label" v-if="false">{{formatDate}}</div>
        <div
          class="table_body"
          ref="container">
          <div
            class="table_body-inner"
            v-for="(item, key) in data"
            :key="key"
          >
            <div
              class="table-tr flex flex-middle lastWin">
              <div class="table-td">
                <div class="lastWin-item_wrapper">
                  <div class="lastWin-item lastWin-item-center color-white">
                    {{getTime(item.timestamp)}}
                  </div>
                </div>
              </div>
              <div class="table-td">
                <div class="lastWin-item_wrapper">
                  <div class="lastWin-item lastWin-item-center color-white">
                    {{item.username}}
                  </div>
                </div>
              </div>
              <div class="table-td">
                <div class="lastWin-item_wrapper">
                  <div class="lastWin-item lastWin-item-center color-white">
                    {{item.bet}} EOS
                  </div>
                </div>
              </div>
              <div class="table-td">
                <div class="lastWin-item_wrapper">
                  <div class="lastWin-item lastWin-item-center color-green">
                    {{item.amount}} EOS
                  </div>
                </div>
              </div>
              <div class="table-td">
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <LoadingLabel v-show="loading"></LoadingLabel>
  </div>
</template>

<script>
  import {getScrollPercent} from "~/components/utils";
  import debounce from 'lodash.debounce';
  import LoadingLabel from '~/components/UI/LoadingLabel';

  export default {
    name: "CommissionsFullBody",
    data() {
      return {
        limit: 20,
        offset: 0,
        page: 1,
        loading: false,
        lastScrollY: 0,
        gq: () => {
        },
        currentDate: null
      }
    },
    components: {
      LoadingLabel
    },
    computed: {
      data() {
        return this.$store.state.players.allReferrals;
      },
      formatDate() {
        const timestamp = this.currentDate || new Date().getTime();
        return new Date(timestamp).toDateString();
      }
    },
    methods: {
      getTime(timestamp) {
        return new Date(timestamp).toLocaleTimeString();
      },
      async getData() {
        this.loading = true;
        await this.$store.dispatch('players/fetchAllReferrals', {
          offset: this.limit * (this.page - 1),
          limit: this.limit
        });
        this.loading = false;
      }
    },
    mounted() {
      this.gq = debounce(this.getData, 800);
      this.getData();
      this.$onWrapperScroll.flush();
      this.$onWrapperScroll.onScroll((e) => {
        if (getScrollPercent(this.$onWrapperScroll.container) > 80 && e.target.scrollTop > this.lastScrollY && !this.loading) {
          this.lastScrollY = e.target.scrollTop;
          this.loading = true;
          this.page += 1;
          this.$nextTick(_ => {
            this.gq(this.today);
          });
        }
      });
    }
  }
</script>
<style
  lang="scss"
  scoped>
  .table_date-label {
    color: white;
    background-color: #37425d;
    font-size: .7rem;
    width: 100%;
    max-width: 120px;
    border-radius: 2px;
    opacity: .8;
    padding: 5px;
    text-align: center;
    margin: 5px auto 0px auto;
  }
</style>
